from dotenv import load_dotenv
from flask import Flask, render_template, request, redirect, send_file, session, flash, url_for, send_from_directory
import mysql.connector
import razorpay
import os
from reportlab.pdfgen import canvas
from reportlab.lib.pagesizes import letter
from io import BytesIO
from reportlab.lib.colors import black, blue, green, white
from flask import send_file, flash

load_dotenv()

app = Flask(__name__)
app.secret_key = os.getenv('SECRET_KEY', 'arbab')


def get_db_connection():
    return mysql.connector.connect(
        host="localhost",
        user="root",
        password="Veeru@2002",
        database="arbab_db"
    )

razorpay_key_id = os.getenv("RAZORPAY_KEY_ID", "rzp_live_bEqiJu4kqFqRm5")
razorpay_secret = os.getenv("RAZORPAY_KEY_SECRET", "FdxGjgjQ6tmyxZa6a1wJ81xD")
client = razorpay.Client(auth=(razorpay_key_id, razorpay_secret))


def get_registration_by_id(registration_id):
    """Helper function to fetch registration data by ID"""
    db = get_db_connection()
    cursor = db.cursor()
    cursor.execute("SELECT * FROM registrations WHERE id = %s", (registration_id,))
    registration = cursor.fetchone()
    cursor.close()
    db.close()
    return registration


@app.route('/')
def index():
    return render_template('index.html')

@app.route('/info')
def info():
    return render_template('info.html')

@app.route('/about')
def about():
    return render_template('about.html')
@app.route('/privacypolicy')
def privacypolicy():
    return render_template('privacypolicy.html')

@app.route('/refundpolicy')
def refundpolicy():
    return render_template('refundpolicy.html')

@app.route('/tearmsandcondition')
def tearmsandcondition():
    return render_template('tearmsandcondition.html')


@app.route('/contact')
def contact():
    return render_template('contact.html')

@app.route('/id_card/<id>', methods=['GET', 'POST'])
def id_card(id):
    db = get_db_connection()
    cursor = db.cursor()
    cursor.execute("SELECT * FROM registrations WHERE id = %s", (id,))
    user = cursor.fetchone()  
    cursor.close()
    db.close()

    if user:
        return render_template('id_card.html', id=id, user=user)
    else:
        return "User not found", 404


@app.route('/login', methods=['GET', 'POST'])
def login():
    if request.method == 'POST':
        username = request.form['email']
        password = request.form['password']

        db = get_db_connection()
        cursor = db.cursor()
        cursor.execute("SELECT * FROM admin_tb WHERE email = %s AND password = %s", (username, password))
        user = cursor.fetchone()
        cursor.close()
        db.close()

        if user:
            session['logged_in'] = True
            session['username'] = user[1]
            session['role'] = user[2]
            return redirect('/dashboard')
        else:
            flash("Invalid username or password!", 'error')
    return render_template('login.html')

@app.route('/dashboard', methods=['GET', 'POST'])
def dashboard():
    if 'logged_in' not in session:
        return redirect(url_for('login'))

    search_query = request.form.get('search_query', '')

    db = get_db_connection()
    cursor = db.cursor()

    # If search query exists, filter the query
    if search_query:
        cursor.execute("SELECT * FROM registrations WHERE name LIKE %s OR email LIKE %s", 
                       (f'%{search_query}%', f'%{search_query}%'))
    else:
        cursor.execute("SELECT * FROM registrations")

    users = cursor.fetchall()
    cursor.close()
    db.close()

    return render_template('dashboard.html', users=users, search_query=search_query)


@app.route('/logout')
def logout():
    session.clear()
    flash('You have been logged out.', 'info')
    return redirect(url_for('login'))

@app.route('/registration', methods=['GET', 'POST'])
def registration():
    if request.method == 'POST':
        name = request.form['name']
        email = request.form['email']
        phone = request.form['phone']
        address = request.form['address']
        company = request.form['company']
        ticket = request.form['ticket']
        gender = request.form['gender']
        referral = request.form['referral']
        role = request.form['role']
        field_to_event = request.form['field_to_event']

        db = get_db_connection()
        cursor = db.cursor()

        try:
            cursor.execute("SELECT COUNT(*) FROM registrations")
            user_count = cursor.fetchone()[0] + 1
            dummy_id = f"ABIL25{str(user_count).zfill(3)}"

            cursor.execute(
                """INSERT INTO registrations 
                (dummy_id, name, email, phone, address, company, role, ticket, gender, referral, field_to_event, payment_status) 
                VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s )""",
                (dummy_id, name, email, phone, address, company, role, ticket, gender, referral, field_to_event, 'Pending')
            )
            db.commit()
            id = cursor.lastrowid  # Get the ID of the newly inserted record
            flash('Registration successful! Please proceed to payment.', 'success')

            print(id)
            return redirect(url_for('pay', id=id))

        except mysql.connector.Error as err:
            db.rollback()
            flash(f"Database error: {err}", 'error')

        finally:
            cursor.close()
            db.close()

    return render_template('registration.html')

@app.route('/pay/<id>', methods=['GET' , 'POST'])
def pay(id):
    print(id)
    registration = get_registration_by_id(id)
    if registration:
        ticket = registration[8]  
        ticket_prices = {"Genaral": 1499, "Executive": 1999, "VIP":2499}
        amount = ticket_prices.get(ticket, 0)

        if amount:
            payment = client.order.create({
                'amount': amount * 100,  # Amount in paise
                'currency': 'INR',
                'payment_capture': '1'
            })
            return render_template('pay.html', payment=payment, razorpay_key_id=razorpay_key_id, id=id)
        else:
            flash("Invalid ticket type!", "error")
    else:
        flash("Registration not found!", "error")
    return redirect(url_for('registration'))

@app.route('/success', methods=['POST','GET'])
def success():
    payment_id = request.form['razorpay_payment_id']
    order_id = request.form['razorpay_order_id']
    signature = request.form['razorpay_signature']
    id = request.form['u_id']
    print(f"Payment ID: {payment_id}, Order ID: {order_id}, Signature: {signature}, Registration ID: {id}")

    params_dict = {
        'razorpay_order_id': order_id,
        'razorpay_payment_id': payment_id,
        'razorpay_signature': signature
    }

    try:
        client.utility.verify_payment_signature(params_dict)
        payment = client.payment.fetch(payment_id)

        if payment['status'] == 'captured':
            flash('Payment Successful!', 'success')

            db = get_db_connection()
            cursor = db.cursor()
            cursor.execute("UPDATE registrations SET payment_id = %s, payment_status = %s WHERE id = %s", 
                           (payment_id, 'Paid', id))
            db.commit()
            cursor.close()

            return redirect(url_for('id_card', id=id)) 
        else:
            flash('Payment not confirmed!', 'error')
            return redirect(url_for('registration'))

    except razorpay.errors.SignatureVerificationError as e:
        flash(f"Payment verification failed: {str(e)}", 'error')
        return redirect(url_for('registration'))
    except Exception as e:
        flash(f"Unexpected error: {str(e)}", 'error')
        return redirect(url_for('registration'))

@app.route('/download_id_card/<int:id>', methods=['GET'])
def download_id_card(id):
    registration = get_registration_by_id(id)
    if registration:
        buffer = BytesIO()

        c = canvas.Canvas(buffer, pagesize=letter)

        base_path = os.path.abspath(os.path.dirname(__file__))
        bg_image_path = os.path.join(base_path, "static/images/newid.png")

        print(f"Background Image Path: {bg_image_path}")

        if os.path.exists(bg_image_path):
            c.drawImage(bg_image_path, 150, 180, width=300, height=530)  
        else:
            flash("Background image not found!", "error")
            return redirect(url_for('index'))
        c.setFont("Times-Roman", 16)  
        c.setFillColorRGB(0, 0, 0) 
        c.drawString(200, 470, f"Name: {registration[2]}")    
        c.drawString(200, 440, f"ID: {registration[1]}") 
        c.drawString(200, 410, f"Email: {registration[3]}")  
        c.drawString(200, 380, f"Company: {registration[6]}")  
        c.drawString(200, 350, f"Role: {registration[7]}")  
        c.drawString(200, 320, f"Ticket: {registration[8]}")
        c.showPage()
        c.save()

        buffer.seek(0)

        return send_file(buffer, as_attachment=True, download_name="id_card.pdf", mimetype="application/pdf")
    else:
        flash("User not found!", "error")
        return redirect(url_for('index'))

@app.route('/download_brochure')
def download_brochure():
    try:
        return send_from_directory('static/files', 'brochure.pdf', as_attachment=True)
    except FileNotFoundError:
        flash("Brochure file not found!", "error")
        return redirect(url_for('index'))

if __name__ == '__main__':
    app.run(debug=True)
